// My Robot - Blit - blit.c
// Nick Sabalausky

#include "gba.h"
#include "userdefs.h"
#include "rand.h"

  // GBA Headers
#include "gfx.h"
#include "sprite.h"
#include "input.h"
#include "mathluts.h"

  // Game Headers
#include "gamedefs.h"
#include "intro.h"
#include "sound.h"
#include "blit.h"
#include "enemyCode.h"
#include "robotShotCode.h"

  // Images
//#include "imagesNotTiled.h"

void Blit(img* pImg, u16 color0, u16 color1, u16 x, u16 y)
{
	int ix, iy;
	u16 dataWidth = pImg->width;
	u16 colorLookup[2] = {color0, color1};
//	u16* screenPtr = screen;
	const u16* dataPtr   = pImg->data;

	for(iy=0; iy<pImg->height; iy++)
	{
		for(ix=0; ix<dataWidth; ix++)
		{
			screen[ix+x+((iy+y)*SCREEN_WIDTH)] = colorLookup[dataPtr[ix+(iy*dataWidth)] & 1];
		}
	}
}

  // Note: This does not perform any clipping!!
/*void BlitFast(img* pImg, u16 color, u16 x, u16 y)
{
	int ix, iy;
	u16 dataWidth = pImg->width;
	u16* screenPtr = screen[x+(y*SCREEN_WIDTH)];
	u16* dataPtr   = pImg->data;
	u16* dataEndPtr;

	for(iy=0; iy<pImg->height; iy++)
	{
		dataEndPtr = dataPtr + dataWidth;

		while()
		{
			
		}

		screenPtr += SCREEN_WIDTH - dataWidth;
	}
}
*/
//void BlitConsoleFever(u16 color0, u16 color1, u16 x, u16 y)
//{
//	Blit(&img_consolefever, color0, color1, x, y);
//}

//void BlitConsoleFeverBoxed(u16 color0, u16 color1, u16 x, u16 y)
//{
//	Blit(&img_consoleFeverBoxed, color0, color1, x, y);
//}

//void BlitEnemy(u16 color0, u16 color1, u16 x, u16 y)
//{
//	Blit(&img_enemyNoTile, color0, color1, x, y);
//}

// END OF FILE ///////////////////////