/*
 * Include all of the basic Macros, etc we'll need to make a GBA game
 * By Erik Gillespie
 */

#ifndef GBA_H
#define GBA_H

#include "gbatypes.h"

#include "gbadma.h"
#include "gbaregs.h"
#include "gbakeys.h"
#include "gbavideo.h"
#include "gbasprite.h"

  // I'm just gonna stick the interrupt stuff in here
#define INT_VBLANK		0x0001
#define INT_HBLANK		0x0002
#define INT_VCOUNT		0x0004
#define INT_TIMER0		0x0008
#define INT_TIMER1		0x0010
#define INT_TIMER2		0x0020
#define INT_TIMER3		0x0040
#define INT_COMM		0x0080
#define INT_DMA0		0x0100
#define INT_DMA1		0x0200
#define INT_DMA2		0x0400
#define INT_DMA3		0x0800
#define INT_KEYBOARD	0x1000
#define INT_CART		0x2000
#define INT_ALL			0x3FFF

void EnableInterupts(u16 interupts);
void DisableInterupts(u16 interupts);

extern u16 introFgColor;

#endif
