// GBA Input System - input.h
// Nick Sabalausky

#ifndef _INPUT_H_
#define _INPUT_H_

extern u16 oldKeys;
extern u16 newKeys;

#define isKeyDown(k)   (newKeys & (k))
#define isKeyUp(k)    !(newKeys & (k))

#define wasKeyDown(k)   (oldKeys & (k))
#define wasKeyUp(k)    !(oldKeys & (k))

#define isKeyPressed(k)   (isKeyDown(k) && wasKeyUp(k))
#define isKeyReleased(k)  (isKeyUp(k) && wasKeyDown(k))

void inline Input_Reset();
void inline Input_Poll();

#endif
// END OF FILE //////////////////////////
