// My Robot - Sound - Sound.c
// Nick Sabalausky

#include "gba.h"
#include "gfx.h"
#include "gamedefs.h"
#include "userdefs.h"
#include "sound.h"

  // Refer to "http://belogic.com/gba" for
  // details on these magic numbers.

void InitSound(void)
{
	REG_SOUNDCNT_X = 0x0080;
	REG_SOUNDCNT_L = 0x3377;
	REG_SOUNDCNT_H = 0x0002;
}

void StartMusic(u8 melodyID)
{
	REG_SOUNDCNT_L = 0xCC77;
	REG_SOUND3CNT_L = 0x0000;

	if(melodyID == 0)
	{
		if(cheats.noIntroMusic)
			REG_SOUNDCNT_L = 0x0000;

		REG_WAVE_RAM0=0x40A8ECFF;
		REG_WAVE_RAM1=0xBF6D4631;
		REG_WAVE_RAM2=0x40A8ECFF;
		REG_WAVE_RAM3=0xBF6D4631;
	}
	else
	{
		if(cheats.noGameMusic)
		{
			songEnded = 1;
			return;
		}

		REG_WAVE_RAM0=0x0368ABDE;
		REG_WAVE_RAM1=0xFDBA8741;
		REG_WAVE_RAM2=0x0368ABDE;
		REG_WAVE_RAM3=0xFDBA8741;
	}

	REG_SOUND3CNT_L = 0x00C0;

	melody = melodyID; // =introMelody
	songEnded = 0;
	songIndex = 0;

	REG_TM0D   = 0x0B00;
	REG_TM0CNT = 0x00C1;
	EnableInterupts(INT_TIMER0);
}

void StopMusic(void)
{
	DisableInterupts(INT_TIMER0);
	REG_SOUNDCNT_L = 0x3377;
}

void PlayTick1(void)
{
//	REG_SOUND1CNT_L = 0x007B;
	REG_SOUND2CNT_L = 0xF4BB;
	REG_SOUND2CNT_H = 0xC600;
}

void PlayTick2(void)
{
//	REG_SOUND1CNT_L = 0x007C;
//	REG_SOUND1CNT_H = 0xF4BD;
//	REG_SOUND1CNT_X = 0xC600;

	REG_SOUND2CNT_L = 0xF4BD;
	REG_SOUND2CNT_H = 0xC600;
}

void PlayTick2Long(void)
{
//	REG_SOUND1CNT_L = 0x007C;
	REG_SOUND2CNT_L = 0xF4B6;
	REG_SOUND2CNT_H = 0xC600;
}

void PlayTick2LowQ(void)
{
//	REG_SOUND1CNT_L = 0x007C;
	REG_SOUND2CNT_L = 0xF47D;
	REG_SOUND2CNT_H = 0xC600;
}

void PlayTick2LongLowQ(void)
{
//	REG_SOUND1CNT_L = 0x007C;
	REG_SOUND2CNT_L = 0xF476;
	REG_SOUND2CNT_H = 0xC600;
}

void PlayTick3(void)
{
	REG_SOUND2CNT_L = 0xF476;
	REG_SOUND2CNT_H = 0xC600;
}

void PlayTick4(void)
{
//	REG_SOUND1CNT_L = 0x007C;
	REG_SOUND2CNT_L = 0x80FE;
	REG_SOUND2CNT_H = 0xC600;
}

void PlayTick5(void)
{
//	REG_SOUND1CNT_L = 0x007C;
//	REG_SOUND1CNT_H = 0xF4BD;
//	REG_SOUND1CNT_X = 0xC600;

	REG_SOUND2CNT_L = 0x84BF;
	REG_SOUND2CNT_H = 0xC680;
}

void PlayBeep1(void)
{
//	REG_SOUND1CNT_L = 0x007C;
	REG_SOUND2CNT_L = 0xF4B3;
	REG_SOUND2CNT_H = 0xC600;
}

void PlayBeep2(void)
{
	REG_SOUND2CNT_L = 0xF450;
	REG_SOUND2CNT_H = 0xC780;
}

void PlayLow1(void)
{
//	REG_SOUND1CNT_L = 0x007B;
	REG_SOUND2CNT_L = 0xF4BB;
	REG_SOUND2CNT_H = 0xC400;
}

void PlayLow2(void)
{
//	REG_SOUND1CNT_L = 0x007B;
	REG_SOUND2CNT_L = 0xF2A5;
	REG_SOUND2CNT_H = 0xC400;
}

void PlayLow3(void)
{
//	REG_SOUND1CNT_L = 0x007C;
	REG_SOUND2CNT_L = 0xF4B3;
	REG_SOUND2CNT_H = 0xC400;
}

void PlayDown1(void)
{
	REG_SOUND1CNT_L = 0x007C;
	REG_SOUND1CNT_H = 0xF49B;
	REG_SOUND1CNT_X = 0xC600;
}

void PlayDown1Long(void)
{
	REG_SOUND1CNT_L = 0x007C;
	REG_SOUND1CNT_H = 0xF489;
	REG_SOUND1CNT_X = 0xC600;
}

void PlayDown2(void)
{
	REG_SOUND1CNT_L = 0x004C;
	REG_SOUND1CNT_H = 0xF281;
	REG_SOUND1CNT_X = 0x8600;
}

void PlayDown3(void)
{
	REG_SOUND1CNT_L = 0x007C;
	REG_SOUND1CNT_H = 0xF289;
	REG_SOUND1CNT_X = 0xC600;
}

void PlayUp1(void)
{
	REG_SOUND1CNT_L = 0x0074;
	REG_SOUND1CNT_H = 0xF489;
	REG_SOUND1CNT_X = 0xC480;
}

void PlayUp2(void)
{
	REG_SOUND1CNT_L = 0x0054;
	REG_SOUND1CNT_H = 0xF79D;
	REG_SOUND1CNT_X = 0xC530;
}

void PlayUp3(void)
{
	REG_SOUND1CNT_L = 0x0044;
	REG_SOUND1CNT_H = 0xF79D;
	REG_SOUND1CNT_X = 0xC530;
}

// From BeLogic's sound channel 3 demo:
const u16 freq[72] = {
44,		// C3
156,
262,
363,
457,
547,
631,
710,
786,
854,
923,
986,
1046,	// C4
1102,
1155,
1205,
1253,
1297,
1339,
1379,
1417,
1452,
1486,
1517,
1546,	// C5
1575,
1602,
1627,
1650,
1673,
1694,
1714,
1732,
1750,
1767,
1783,
1798,	// C6
1812,
1825,
1837,
1849,
1860,
1871,
1881,
1890,
1899,
1907,
1915,
1923,	// C7
1930,
1936,
1943,
1949,
1954,
1959,
1964,
1969,
1974,
1978,
1982,
1985,	// C8
1988,
1992,
1995,
1998,
2001,
2004,
2006,
2009,
2011,
2013,
2015
}; 

// END OF FILE /////////////